
#ifdef DLL_EXPORT
#define DECL __declspec(dllexport)
#endif


#ifndef DLL_EXPORT
#define DECL __declspec(dllimport)
#endif

#define LPCHAR  unsigned char*
#define LPSHORT unsigned short*
#define UCHAR   unsigned char

/*
	 
*/
typedef DWORD (*T_BC_Debug)(DWORD Id);
typedef DWORD (*T_RT_Debug)(DWORD Id);
typedef DWORD (*T_MT_Debug)(DWORD Id);

extern "C" DECL DWORD BC_Debug(DWORD Id);
extern "C" DECL DWORD RT_Debug(DWORD Id);
extern "C" DECL DWORD MT_Debug(DWORD Id);
/*
		     
*/
typedef DWORD (*T_Config_GetDeviceName)   (DWORD Number, LPCHAR Name, DWORD NameSize);
typedef UCHAR (*T_Config_GetChannelQuantity)(LPCHAR Name);
typedef DWORD (*T_Config_SetTermResistor) (LPCHAR Name, UCHAR Channel, UCHAR Bus, UCHAR State);
typedef UCHAR (*T_Config_GetTermResistor) (LPCHAR Name, UCHAR Channel, UCHAR Bus);

extern "C" DECL DWORD Config_GetDeviceName   (DWORD Number, LPCHAR Name, DWORD NameSize);
extern "C" DECL UCHAR Config_GetChannelQuantity(LPCHAR Name);
extern "C" DECL DWORD Config_SetTermResistor (LPCHAR Name, UCHAR Channel, UCHAR Bus, UCHAR State);
extern "C" DECL UCHAR Config_GetTermResistor (LPCHAR Name, UCHAR Channel, UCHAR Bus);


/*
		       
*/
/*typedef struct _BC_STATUS
{
		USHORT  value;
}BC_STATUS, *LPBC_STATUS;
*/

#define STATSTOP_SQR    0x20
#define STATSTOP_BUSY   0x08
#define STATSTOP_SSF    0x04
#define STATSTOP_MSGERR 0x02

#define CONTROL_EOM		0x8000
#define CONTROL_RETRY   0x4000
#define CONTROL_STATSET 0x2000
#define CONTROL_ERROR   0x1000
#define CONTROL_NORESP  0x0800

#define RESPONSE_TERMINAL_FLAG                  0x001
#define RESPONSE_BUS_CONTROL_ACCEPTANCE         0x002
#define RESPONSE_SUBSYSTEM_FLAG                 0x004
#define RESPONSE_BUSY                           0x008
#define RESPONSE_BROADCAST_COMMAND_RESEIVED     0x010
#define RESPONSE_SERVICE_REQUEST                0x100
#define RESPONSE_INSTRUMENTATION                0x200
#define RESPONSE_MESSAGE_ERROR                  0x400


typedef struct _BC_CONFIG{
				UCHAR   Reply;          //2 bits
				UCHAR   MainBus;        //1 bit
				UCHAR   AnswerTimeout;  //2 bit
				UCHAR   Reserve;
				USHORT  MessageDelay;   //12 bit
				USHORT  FrameDelay;     //16 bit
				UCHAR   ErrorStop;      //1 bit
				UCHAR   StatStop;       //4 bit
}BC_CONFIG, *PBC_CONFIG;

// ,      
typedef struct _MessageCommon {              //
				USHORT      Format;         // 
				USHORT      ControlWord;
				USHORT      CommandWord;
				USHORT      MessageData[8+32];  //  -    
} MessageCommon, *PMessageCommon;

typedef struct _Message1 {
		USHORT      Format;         // 
		USHORT      ControlWord;    //
        USHORT      CommandWord;    //
        USHORT      Size;           //    
        USHORT      Data[32];       // 32  
        USHORT      StatusResponse; //
} Message1, *PMessage1;

typedef struct _Message2 {
        USHORT      Format;         // 
        USHORT      ControlWord;    //
		USHORT      CommandWord;    //
        USHORT      Size;           //    
        USHORT      Data[32];       // 32  
        USHORT      StatusResponse; //
} Message2, *PMessage2;

typedef struct _Message3 {             //  
        USHORT      Format;         // 
        USHORT      ControlWord;    //
        USHORT      CommandWord;    //
        USHORT      Size;           //    
        USHORT      Data[32];       // 32  
        USHORT      SecondCommand;
		USHORT      TStatusResponse;
        USHORT      RStatusResponse; //
} Message3, *PMessage3;

typedef struct _Message4 {
        USHORT      Format;         // 
        USHORT      ControlWord;    //
        USHORT      CommandWord;    //
        USHORT      StatusResponse; //
} Message4, *PMessage4;

typedef struct _Message5 {
        USHORT      Format;         // 
        USHORT      ControlWord;    //
        USHORT      CommandWord;    //
        USHORT      StatusResponse; //
        USHORT      Data;
} Message5, *PMessage5;

typedef struct _Message6 {
        USHORT      Format;         // 
		USHORT      ControlWord;    //
        USHORT      CommandWord;    //
        USHORT      Data;
        USHORT      StatusResponse; //
} Message6, *PMessage6;

typedef struct _Message7 {
        USHORT      Format;         // 
        USHORT      ControlWord;    //
        USHORT      CommandWord;    //
        USHORT      Size;           //    
        USHORT      Data[32];
} Message7, *PMessage7;

typedef struct _Message8 {
        USHORT      Format;         // 
        USHORT      ControlWord;    //
        USHORT      CommandWord;    //
		USHORT      Size;           //    
        USHORT      Data[32];       // 32  
        USHORT      SecondCommand;
		USHORT      TStatusResponse;
} Message8, *PMessage8;

typedef struct _Message9 {
        USHORT      Format;         // 
        USHORT      ControlWord;    //
        USHORT      CommandWord;    //
} Message9, *PMessage9;

typedef struct _Message10 {
        USHORT      Format;         // 
        USHORT      ControlWord;    //
        USHORT      CommandWord;    //
        USHORT      Data;
} Message10, *PMessage10;

#define COMMAND_WORD( RT_Address, SubAddress, DataWordCount ) ( \
        ((0x1F & (RT_Address)) << 11) | ((0x1F & (SubAddress)) << 5) | (0x1F & (DataWordCount)) \
)
#define COMMAND_WORD_RULE( RT_Address, ModeCode ) ( \
        ((0x1F & (RT_Address)) << 11) | (0x1F & (ModeCode)) \
)

//typedef UCHAR (*T_BC_GetChannelQuantity)(LPCHAR Name);
typedef DWORD (*T_BC_OpenChannel)(LPCHAR Name, CHAR Channel, LPDWORD lpId, LPHANDLE lpEvent);
typedef DWORD (*T_BC_CloseChannel)(DWORD Id);
typedef DWORD (*T_BC_AddMessage)(DWORD Id, CHAR Frame, PMessageCommon pMessage);
typedef DWORD (*T_BC_GetMessage)(DWORD Id, CHAR Frame, PMessageCommon pMessage, WORD Number);
typedef DWORD (*T_BC_Start)(DWORD Id, CHAR Frame);
typedef DWORD (*T_BC_Configure)(DWORD Id, PBC_CONFIG pConfig);

//extern "C" DECL UCHAR BC_GetChannelQuantity(LPCHAR Name);
extern "C" DECL DWORD BC_OpenChannel(LPCHAR Name, CHAR Channel, LPDWORD lpId, LPHANDLE  lpEvent);
extern "C" DECL DWORD BC_CloseChannel(DWORD Id);
extern "C" DECL DWORD BC_AddMessage(DWORD Id, CHAR Frame, PMessageCommon pMessage);
extern "C" DECL DWORD BC_GetMessage(DWORD Id, CHAR Frame, PMessageCommon pMessage, WORD Number);
extern "C" DECL DWORD BC_Start(DWORD Id, CHAR Frame);
extern "C" DECL DWORD BC_Configure(DWORD Id, PBC_CONFIG pConfig);

//extern "C" DECL DWORD BC_GetStatus(DWORD Id, LPBC_STATUS lpBCStatus);
//extern "C" DECL DWORD BC_SetFrameGAP(DWORD Id, DWORD Gap);
//extern "C" DECL DWORD BC_SetRTC(DWORD Id, BOOLEAN State);

/*
				       
*/
//,   
//#define EV_RECEIVE      0x01
//#define EV_SEND         0x02
//#define EV_ERRROR       0x03
//#define EV_OVERFLOW     0x04



#define EV_FLAG_SUCCESS		0x01
#define EV_FLAG_BUS			0x02
#define EV_FLAG_OVERWRITE	0x08
//    ,   .
typedef struct _EvCommon{
		CHAR    Format;	//1..10
		CHAR	Flags;	//OverWrite | Invalid | Bus | Success
		CHAR    Subaddr;
		CHAR    Size_Command;           //    Data
		USHORT  Data[32];       //  
} EvCommon, *PEvCommon;

typedef struct _RT_CONFIG{
	ULONG    RuleCommandEnable;          //
	UCHAR    Fault;
	UCHAR    ReceiveParameters;
	USHORT   AnswerBits;
}RT_CONFIG, *PRT_CONFIG;

#define	CONFIG_FAULT_RT_UPDATE						0x01
#define	CONFIG_FAULT_RT_OVERWRITE					0x02

#define	CONFIG_RECEIVEPARAMETERS_IGNOREBROADCAST	0x01
#define	CONFIG_RECEIVEPARAMETERS_FORBIDBUSA			0x02
#define	CONFIG_RECEIVEPARAMETERS_FORBIDBUSB			0x04

#define	CONFIG_ANSWERBITS_ERROR_IN_MESSAGE			0x0400
#define	CONFIG_ANSWERBITS_TRANSMIT_ANSWER_WORD		0x0200
#define	CONFIG_ANSWERBITS_SERVICE_REQUEST			0x0100
#define	CONFIG_ANSWERBITS_BROADCAST_RECEIVED		0x0010
#define	CONFIG_ANSWERBITS_BUSY_BUS_AGENT			0x0008
#define	CONFIG_ANSWERBITS_FAULT_BUS_AGENT			0x0004
#define	CONFIG_ANSWERBITS_INTERFACE_RECEIVED		0x0002
#define	CONFIG_ANSWERBITS_FAULT_RT					0x0001

//typedef UCHAR (*T_RT_GetChannelQuantity)(LPCHAR Name);
typedef DWORD (*T_RT_OpenChannel)(LPCHAR Name, CHAR Channel, LPDWORD lpId, LPHANDLE     lpEvent);
typedef DWORD (*T_RT_CloseChannel)(DWORD Id);
typedef DWORD (*T_RT_SetMessage) (DWORD Id, CHAR SubAddr, USHORT DataSize, PUSHORT Data);
typedef DWORD (*T_RT_GetEvent) (DWORD Id, PEvCommon pEvCommon);
typedef DWORD (*T_RT_Start)(DWORD Id, UCHAR Address);
typedef DWORD (*T_RT_Stop)(DWORD Id);
typedef DWORD (*T_RT_SetRequest)(DWORD Id, USHORT Vector);
typedef DWORD (*T_RT_SetESCW)(DWORD Id, USHORT ESCW);
typedef	DWORD (*T_RT_SetConfig)(DWORD Id, PRT_CONFIG pConfig);
typedef	DWORD (*T_RT_GetConfig)(DWORD Id, PRT_CONFIG pConfig);
typedef DWORD (*T_RT_IOBonding)(DWORD Id, DWORD SubAddress);

//extern "C" DECL UCHAR RT_GetChannelQuantity(LPCHAR Name);
extern "C" DECL DWORD RT_OpenChannel(LPCHAR Name, CHAR Channel, LPDWORD lpId, LPHANDLE  lpEvent);
extern "C" DECL DWORD RT_CloseChannel(DWORD Id);
extern "C" DECL DWORD RT_SetMessage (DWORD Id, CHAR SubAddr, USHORT DataSize, PUSHORT Data);
extern "C" DECL DWORD RT_GetEvent (DWORD Id, PEvCommon pEvCommon);
extern "C" DECL DWORD RT_Start(DWORD Id, UCHAR Address);
extern "C" DECL DWORD RT_Stop(DWORD Id);
extern "C" DECL DWORD RT_SetRequest(DWORD Id, USHORT Vector);
extern "C" DECL DWORD RT_SetESCW(DWORD Id, USHORT ESCW);
extern "C" DECL	DWORD RT_SetConfig(DWORD Id, PRT_CONFIG pConfig);
extern "C" DECL	DWORD RT_GetConfig(DWORD Id, PRT_CONFIG pConfig);
extern "C" DECL	DWORD RT_IOBonding(DWORD Id, DWORD SubAddress);

/*extern "C" DECL DWORD RT_GetStatus(DWORD Id, , LPRT_STATUS lpRTStatus);
extern "C" DECL
extern "C" DECL
*/

/*
		       
*/
#define STATUS_MT_FIFO_FULL     0x01
#define STATUS_MT_CNT_OVF       0x02

//typedef UCHAR (*T_MT_GetChannelQuantity)(LPCHAR Name);
typedef DWORD (*T_MT_Open)(LPCHAR Name, CHAR ChannelNumber, DWORD* lpId, HANDLE* lpEvent);
typedef DWORD (*T_MT_Close)(DWORD Id);
typedef DWORD (*T_MT_Start)(DWORD Id);
typedef DWORD (*T_MT_Get)(DWORD Id, DWORD* Buffer, WORD BufferSize, WORD* pInBuffer, DWORD* StateFlags);
typedef DWORD (*T_MT_Stop)(DWORD Id);

typedef DWORD (*T_MT_AllStart)(DWORD Id1, DWORD Id2, DWORD Id3);
typedef DWORD (*T_MT_AllStop)(DWORD Id1, DWORD Id2, DWORD Id3);

//extern "C" DECL UCHAR MT_GetChannelQuantity(LPCHAR Name);
extern "C" DECL DWORD MT_Close(DWORD Id);
extern "C" DECL DWORD MT_Open(LPCHAR Name, CHAR ChannelNumber, DWORD* lpId, HANDLE* lpEvent);
extern "C" DECL DWORD MT_Start(DWORD Id);
extern "C" DECL DWORD MT_Get(DWORD Id, DWORD* Buffer, WORD BufferSize, WORD* pInBuffer, DWORD* StateFlags);
extern "C" DECL DWORD MT_Stop(DWORD Id);

extern "C" DECL DWORD MT_AllStart(DWORD Id1, DWORD Id2, DWORD Id3);
extern "C" DECL DWORD MT_AllStop(DWORD Id1, DWORD Id2, DWORD Id3);

